#!/usr/bin/env python
# -*- coding: utf-8 -*-
#from scapy.all import *
import os
import httplib

class ms_Sniffer():
	
	def __init__(self,limit,iface,filter=""):
		
		logging.getLogger("scapy.runtime").setLevel(logging.ERROR)
		self.filter = filter
		self.limit = limit
		self.iface = iface
		self.hostSniffed = []
		self.SnifferSummary = []
		self.__startSniffer()
	
	# Init Sniffer depend if filter is selected or not
	def __startSniffer(self):
		
		self.finSniff = sniff(iface=self.iface,count=self.limit) if self.__selectedFilter==True else sniff(iface=self.iface,filter=self.filter,count=self.limit)
		self.__showDataHeaders()
		self.__showSummary()
		
	def __showDataHeaders(self):
		
		#Algunos hosts no poseen alguno de estos items por lo que provocan un excepcion y se crea un diccionario vacio. ARREGLAR
		numDictionary = 0
		for tcount in range(0,len(self.finSniff)):
			try:
				self.hostSniffed.append({})
				self.hostSniffed[numDictionary]["dst"] = self.finSniff[tcount].dst
				self.hostSniffed[numDictionary]["src"] = self.finSniff[tcount].src
				self.hostSniffed[numDictionary]["type"] = self.finSniff[tcount].type
				self.hostSniffed[numDictionary]["version"] = self.finSniff[tcount].version
				self.hostSniffed[numDictionary]["ihl"] = self.finSniff[tcount].ihl
				self.hostSniffed[numDictionary]["tos"] = self.finSniff[tcount].tos
				self.hostSniffed[numDictionary]["len"] = self.finSniff[tcount].len
				self.hostSniffed[numDictionary]["id"] = self.finSniff[tcount].id
				self.hostSniffed[numDictionary]["flags"] = self.finSniff[tcount].flags
				self.hostSniffed[numDictionary]["frag"] = self.finSniff[tcount].frag
				self.hostSniffed[numDictionary]["ttl"] = self.finSniff[tcount].ttl
				self.hostSniffed[numDictionary]["proto"] = self.finSniff[tcount].proto
				self.hostSniffed[numDictionary]["chksum"] = self.finSniff[tcount].chksum
				self.hostSniffed[numDictionary]["src"] = self.finSniff[tcount].src
				self.hostSniffed[numDictionary]["dst"] = self.finSniff[tcount].dst
				self.hostSniffed[numDictionary]["options"] = self.finSniff[tcount].options
				self.hostSniffed[numDictionary]["sport"] = self.finSniff[tcount].sport
				self.hostSniffed[numDictionary]["dport"] = self.finSniff[tcount].dport
				self.hostSniffed[numDictionary]["len"] = self.finSniff[tcount].len
				self.hostSniffed[numDictionary]["chksum"] = self.finSniff[tcount].chksum
				self.hostSniffed[numDictionary]["load"] = self.finSniff[tcount].load	
				numDictionary += 1
			except:
				continue
	
	# Hay que redireccionar la salida de summary a la tabla self.SnifferSummary
	def __showSummary(self):
		
		self.finSniff.summary()
	
	# Manage Filter Selection
	def __selectedFilter(self):
		
		if self.filter=="":
			return False
		else:
			return 
	
	def _resultSniffer(self):
		return self.hostSniffed,self.SnifferSummary
		
class ms_portScanner:
	
	def __init__(self,dnsIp):
				
		self.dnsIp = dnsIp
		self.portFirewall = {}
		self.statusPort = {}
		self.__scanPFilter()
		self.__portStatus()
		self.__showPortStatus()
	
	def __scanPFilter(self):	
		
		for port in range(0,30): 
			resp,uresp = sr(IP(dst=self.dnsIp)/TCP(dport=[port],flags="A"),timeout=0.1) 
			if len(resp) != 0: 
				for s,r in resp:
					if s[TCP].dport==s[TCP].sport: 
						self.portFirewall[port] = False
					else:
						self.portFirewall[port] = True
			else: 
				self.portFirewall[port] = True
	
	def __portStatus(self): # XMAS Scan

		for port in self.portFirewall:
			resp,uresp = sr(IP(dst=self.dnsIp)/TCP(dport=port,flags="FPU"),timeout=0.1)
			if len(resp) != 0:
				for s,r in resp:
					if s[TCP].dport==s[TCP].sport:
						self.statusPort[port] = "Open"
					else:
						self.statusPort[port] = "Close"
			else:
				self.statusPort[port] = "Close"
	def __showPortStatus(self):
		
		# Clear Window
		if os.name=="nt":
			os.system("cls")
		else:
			os.system("clear")
			
		# Show Status	
		print "-- If port is filtered the status may not be reliable --\n"
		for port in self.statusPort:
			if self.portFirewall[port]:
				print "Port Filtered: " + str(port) + "  " + self.statusPort[port]
			else:
				print "Port NoN Filtered: " + str(port) + "  " + self.statusPort[port]

class serverBanner:
	
	def __init__(self,url):
		self.url = url.replace("http://","")
		self.infoDict = {}
		self.__httpConnect()
		self.__httpRequest()
		
	def __httpConnect(self):
		try:
			self.connect = httplib.HTTPConnection(self.url)
		except:
			self.infoDict = {"Error":"No Connected"}
			return self.infoDict
			
	def __httpRequest(self):
		
		for method in ("HEAD"):
			try:
				self.connect.request(method,"/")
				self.response = self.connect.getresponse()
				self.__httpResponse()
				break;
			except:
				self.connect.close()
				self.__httpConnect()
				continue
	
	def __httpResponse(self):
			auxDict = {}
			for responsex in self.response.getheaders():
				try:
					auxDict[responsex[0]] = responsex[1]
				except:
					continue
			self.infoDict = auxDict
	
	def _returnDictionary(self):
		return self.infoDict
